'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @copyright 2016 Andrey Popp <8mayday@gmail.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @license MIT
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CTagsWebpackPlugin = (function () {
  function CTagsWebpackPlugin() {
    var filename = arguments.length <= 0 || arguments[0] === undefined ? 'tags' : arguments[0];

    _classCallCheck(this, CTagsWebpackPlugin);

    this.filename = filename;
    this.tags = {};
  }

  _createClass(CTagsWebpackPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      compiler._cTagsWebpackPlugin = this;
      compiler.plugin('emit', function (compilation, callback) {
        _this.flush(callback);
      });
    }
  }, {
    key: 'flush',
    value: function flush(callback) {
      var out = [TAGS_BANNER];
      var filenames = Object.keys(this.tags);
      for (var i = 0; i < filenames.length; i++) {
        var filename = filenames[i];
        var tags = this.tags[filename];
        for (var j = 0; j < tags.length; j++) {
          out.push(formatTag(tags[j]));
        }
      }
      _fs2.default.writeFile(this.filename, out.join('\n'), { flags: 'w' }, function (err) {
        return callback(err);
      });
    }
  }]);

  return CTagsWebpackPlugin;
})();

exports.default = CTagsWebpackPlugin;

function formatTag(tag) {
  var line = [tag.tagname, tag.filename, tag.loc.start.line, ';"', tag.type];
  if (tag.options) {
    var keys = Object.keys(tag.options);
    for (var i = 0; i < keys.length; i++) {
      line.push(keys[i] + ':' + tag.options[keys[i]]);
    }
  }
  return line.join('\t');
}

var TAGS_BANNER = ['!_TAG_FILE_FORMAT	2	/extended format/', '!_TAG_FILE_SORTED	0	/0=unsorted, 1=sorted, 2=foldcase/'].join('\n');
